<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form
      v-show="showSearch"
      ref="queryForm"
      :model="queryParams"
      size="small"
      label-width="68px"
    >
      <QueryFormWrapper>
        <el-col :span="8">
          <el-form-item label="备料单号" prop=" prepareOrderNo">
            <el-input
              v-model="queryParams.prepareOrderNo"
              placeholder="请输入备料单号"
              clearable
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="供应商" prop="supplierName">
            <el-input
              v-model="queryParams.supplierName"
              placeholder="请输入供应商名称"
              clearable
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="备料状态" prop="syntheticalStatus">
            <DictSelect
              v-model="queryParams.syntheticalStatus"
              placeholder="请选择备料状态"
              dict-type="WMS_MATERIAL_PREPARATION_STATUS"
            />
          </el-form-item>
        </el-col>
        <div slot="right">
          <el-form-item class="text-right">
            <el-button
              type="primary"
              icon="el-icon-search"
              size="mini"
              @click="handleQuery"
              >查询</el-button
            >
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
              >重置</el-button
            >
          </el-form-item>
        </div>
      </QueryFormWrapper>
    </el-form>
    <!-- 操作工具 -->
    <el-row :gutter="10" class="mb10">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          >新增</el-button
        >
      </el-col>
      <right-toolbar
        :columns="columnsList"
        :show-search.sync="showSearch"
        @saveSetting="getList"
        @queryTable="getList"
      />
    </el-row>

    <!-- 列表 -->
    <AutoResizer :given-height="188">
      <template #default="{ height }">
        <el-table
          v-if="columnsList.length > 0"
          v-loading="loading"
          :data="list"
          border
          :height="height"
        >
          <el-table-column
            v-if="columnsList[0].visible"
            :key="Math.random()"
            label="备料单号"
            align="center"
            prop="prepareOrderNo"
            width="200"
            fixed="left"
            show-overflow-tooltip
          >
            <template slot-scope="scope">
              <div class="custom-column">
                <el-button type="text" @click="handleDetail(scope.row)">{{
                  scope.row.prepareOrderNo
                }}</el-button>
              </div>
            </template>
          </el-table-column>
          <el-table-column
            v-if="columnsList[1].visible"
            :key="Math.random()"
            label="供应商"
            align="center"
            prop="supplierName"
            width="160"
            show-overflow-tooltip
          />
          <el-table-column
            v-if="columnsList[2].visible"
            :key="Math.random()"
            label="备料状态"
            align="center"
            prop="syntheticalStatus"
            width="120"
          >
            <template slot-scope="scope">
              <dict-tag
                :type="DICT_TYPE.WMS_MATERIAL_PREPARATION_STATUS"
                :value="scope.row.syntheticalStatus"
              />
            </template>
          </el-table-column>
          <el-table-column
            v-if="columnsList[3].visible"
            :key="Math.random()"
            label="创建时间"
            align="center"
            prop="createTime"
            width="160"
          >
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.createTime) }}</span>
            </template>
          </el-table-column>
          <el-table-column
            v-if="columnsList[4].visible"
            :key="Math.random()"
            label="备注"
            align="center"
            prop="remark"
            min-width="150"
          />
          <el-table-column
            label="操作"
            align="center"
            class-name="small-padding fixed-width"
            width="80"
            fixed="right"
          >
            <template slot-scope="scope">
              <el-button
                v-hasPermi="['wms:synthetical-send-master:delete']"
                size="mini"
                type="text"
                icon="el-icon-delete"
                class="text-danger"
                :disabled="scope.row.syntheticalStatus === 2"
                @click="handleDelete(scope.row)"
                >删除</el-button
              >
            </template>
          </el-table-column>
        </el-table>
      </template>
    </AutoResizer>

    <!-- 分页组件 -->
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNo"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 备料明细 -->
    <ProductionPreparationDetail
      ref="productDetail"
      @prepareComplete="getList"
      @commitComplete="getList"
    />
  </div>
</template>

<script>
import {
  updateWorkBatchBom,
  getMainDetailPage,
  deleteMasterPrepare,
} from "@/api/wms/inLibrary/productionPreparation";
import ProductionPreparationDetail from "../components/ProductionPreparationDetail.vue";
import { getFormColumnsList } from "@/api/system/saveColumns/index";
import { mapGetters } from "vuex";
import { isArray } from "min-dash";

export default {
  name: "OutsourcePreparation",
  components: {
    ProductionPreparationDetail,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用料清单（投料单）列表
      list: [],
      // 是否显示弹出层
      open: false,
      currentRows: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        materialNo: null,
        materialName: null,
        prepareOrderNo: null,
        syntheticalStatus: null,
        prepareType: 1,
      },
      // 显示隐藏列参数
      columns: [
        { key: 0, label: "备料单号", visible: true },
        { key: 1, label: "供应商", visible: true },
        { key: 2, label: "备料状态", visible: true },
        { key: 3, label: "创建时间", visible: true },
        { key: 4, label: "备注", visible: true },
      ],
      // 显示隐藏持久化参数
      columnsList: [],
    };
  },
  computed: {
    ...mapGetters(["userId"]),
  },
  created() {
    // 获取显隐列列表
    this.getColumnsList();
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 执行查询
      getMainDetailPage(this.queryParams)
        .then((response) => {
          this.list = response.data.list;
          this.total = response.data.total;
        })
        .finally(() => {
          this.loading = false;
        });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        orderType: undefined,
        erpId: undefined,
        erpOrderNo: undefined,
        erpOrderTime: undefined,
        status: undefined,
        workErpId: undefined,
        workOrderNo: undefined,
        workDetailErpId: undefined,
        productCode: undefined,
        productUnit: undefined,
        productName: undefined,
        productModel: undefined,
        productAmount: undefined,
        departmentNo: undefined,
        remark: undefined,
        erpMdtime: undefined,
        erpMark: undefined,
        prepareOrderNo: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.queryParams.prepareOrderNo = undefined;
      this.handleQuery();
    },
    // 关联投料单
    handleView(row) {
      const { materialNo } = row;
      this.$refs.productDetail.open = true;
      this.$refs.productDetail.queryParams.materialNo = materialNo;
      this.$refs.productDetail.title = "查看备料详情";
    },
    // 完成备料
    finishPreparation() {
      if (this.currentRows.length <= 0) {
        this.$modal.msgWarning("备料数据不能为空，请选择您要备料的数据~");
        return;
      }
      this.$modal
        .confirm("您正在备料操作，是否继续？")
        .then(() => {
          updateWorkBatchBom(this.currentRows).then((res) => {
            this.$modal.msgSuccess("操作成功");
            this.getList();
          });
        })
        .catch(() => {
          this.$modal.msg("您已取消操作");
        });
    },
    handleAdd() {
      this.$router.push({ path: "/inLibrary/outsource-preparation-detail" });
    },
    handleDetail(row) {
      const { id } = row;
      this.$router.push({
        path: "/inLibrary/outsource-preparation-detail",
        query: { masterId: id },
      });
    },
    // 删除
    handleDelete(row) {
      const { id, prepareOrderNo } = row;
      this.$modal
        .confirm('是否确认删除备料单号为"' + prepareOrderNo + '"的数据项?')
        .then(function () {
          return deleteMasterPrepare(id);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    // 获取显示隐藏列
    getColumnsList() {
      const { componentName } = this.$route.meta || null;
      const params = {
        userId: this.userId,
        vueForm: componentName,
      };
      getFormColumnsList(params)
        .then((res) => {
          if (isArray(res.data)) {
            this.columnsList = res.data.length === 0 ? this.columns : res.data;
            // 对比默认数据和接口数据，将缺失的列添加到接口数据中
            this.columnsList = this.columns.reduce((acc, defaultColumn) => {
              const found = res.data.find(
                (apiColumn) => apiColumn.key === defaultColumn.key
              );
              if (!found) {
                acc.push({
                  ...defaultColumn,
                  vueForm: componentName,
                  userId: this.userId,
                  id: null,
                });
              }
              return acc;
            }, res.data);
          } else {
            this.columnsList = this.columns;
          }
        })
        .catch((err) => {
          if (err) {
            this.columnsList = this.columns;
          }
        });
    },
  },
};
</script>
<style scoped>
/* 表格使用了插槽复制的 */
.custom-column {
  position: relative;
}
.custom-column .el-button {
  user-select: text;
}
</style>
